package com.kingfore.service.impl;


import com.alibaba.fastjson2.JSONObject;
import com.kingfore.utils.BeanMapUtils;
import com.kingfore.utils.output;
import lombok.extern.java.Log;
import net.dreamlu.iot.mqtt.spring.client.MqttClientTemplate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.mongodb.core.BulkOperations;
import org.springframework.data.mongodb.core.MongoTemplate;
import org.springframework.data.mongodb.core.query.Criteria;
import org.springframework.data.mongodb.core.query.Query;
import org.springframework.stereotype.Service;
import org.springframework.util.ObjectUtils;

import java.nio.charset.StandardCharsets;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

@Log
@Service
public class MqttSendImpl {
    @Autowired
    MongoTemplate mongoTemplate;
    @Autowired
    private MqttClientTemplate client;
    @Autowired
    MqttReviceImpl mqttRevice;
    public boolean publish(String body) {
        client.publish("/test/client", body.getBytes(StandardCharsets.UTF_8));
        return true;
    }

//    public output publishBGL(Object data) {
//        //默认值
//        String topic="bgl/down/gl5022310031013";
//        String pushMessage = "{\"SW_00\":{\"sw_cur\":99.0,\"sw_vol\":2.0},\"SW_01\":{\"sw_cur\":11.0,\"sw_vol\":12.0}}";
//        //请求示例
//        String type="bgl";
//        String rwType = "down";
//        String sn="gl5022310031013";
//        String deviceCode = "SW_00";
//        String dataCode = "sw_cur";
//        String dataValue = "99.0";
//
//        if (ObjectUtils.isEmpty(data)) return new output().methodError("提交参数不能为空！！！", "提交参数不能为空！！！");
//        JSONObject paramObject = JSONObject.from(data);
//        try {
//            if( paramObject.containsKey("flexem_timestamp")){
//                List timestamp = (List) paramObject.get("flexem_timestamp");
//            }
//            if( paramObject.containsKey("实际数据")){
//                List realDataList = (List) paramObject.get("实际数据");
//            }
//            if( paramObject.containsKey("报警状态")){
//                List warningStatusList = (List) paramObject.get("报警状态");
//            }
//            if( paramObject.containsKey("报警设置")){
//                List warningSetList = (List) paramObject.get("报警设置");
//            }
//            if( paramObject.containsKey("设备名称")){
//                List deviceName = (List) paramObject.get("设备名称");
//            }
//
//            MqttBGLVO mqttBGLVO =  BeanMapUtils.mapToBean(JSONObject.from(paramObject.get("data")), MqttBGLVO.class);
//            //默认下发类型
//            mqttBGLVO.setRwType("down");
//
//            JSONObject jsonObject = new JSONObject();
//            JSONObject jsonData = new JSONObject();
//            jsonData.put(mqttBGLVO.getDataCode(),Long.valueOf(mqttBGLVO.getDataValue().toString()));
//            jsonObject.put(mqttBGLVO.getDeviceCode(),jsonData);
//
//            topic = mqttBGLVO.getTopic()+"/"+mqttBGLVO.getRwType()+"/"+mqttBGLVO.getSn();
//            pushMessage = jsonObject.toJSONString().replace("\\","");
//
//            log.info("发送消息,topic:"+topic+",pushMessage:"+pushMessage);
//            client.publish(topic,pushMessage.getBytes());
//
//        } catch (IllegalAccessException e) {
//            throw new RuntimeException(e);
//        } catch (InstantiationException e) {
//            throw new RuntimeException(e);
//        }
//        return Result.success("发布消息,topic:"+topic+",message:"+pushMessage);
//    }
//
//    /**
//     * 下送空调指令
//     * @param data
//     * @return
//     */
//
//    public Result publishAC(Object data) {
//
//        //默认值
//        String topic="bgl/down/gl5022328038082";
//        String pushMessage = "{\"type\":\"单选\",\"cid\":[],\"name\":\"运行模式控制\",\"state\":\"4\",\"ciname\":\"AC_00_16\"}";
//        //请求示例
//        String type="bgl";
//        String rwType = "down";
//        String sn="gl5022328038082";
//        String deviceCode = "AC_00";
//        String dataCode = "";
//        String dataValue = "";
//
//
//        Map acModel= ImmutableMap.of("自动",1 ,"制冷",2 ,"除湿",4 ,"送风",8 ,"制热",16);
//        Map ac_nfc_Model= ImmutableMap.of("开",1 ,"关",0 );
//
//
//        if (ObjectUtils.isEmpty(data)) return Result.error("提交参数不能为空");
//        JSONObject paramObject = JSONObject.from(data);
//        try {
//
//            MqttSendACVO mqttSendACVO =  BeanMapUtils.mapToBean(JSONObject.from(paramObject), MqttSendACVO.class);
//            String dataNum = mqttSendACVO.getCiname().replace("AC_00_","");
//
//            List<DatacodeExtVO>  datacodeExtVOList= mqttRevice.getDataCodeExt()
//                    .stream().filter(f->f.getDataCode().contains(dataNum) && f.getDataName().equals(mqttSendACVO.getName()))
//                    .collect(Collectors.toList());
//            dataCode= datacodeExtVOList.stream().findFirst().orElseGet(null).getDataCode();
//
//            //查询空调状态
//            BulkOperations ops = mongoTemplate.bulkOps(BulkOperations.BulkMode.UNORDERED, "realData");
//            Query qu = Query.query(Criteria.where("dataCode").regex(dataNum));
//            List<Map> deviceAll = mongoTemplate.find(qu, Map.class, "realData");
//            String ac_stmpc = deviceAll.stream().filter(f->f.get("dataCode").toString().contains("ac_stmps")).map(m->{return m.get("value").toString();}).findFirst().get();
//            String ac_modes = deviceAll.stream().filter(f->f.get("dataCode").toString().contains("ac_modes")).map(m->{return m.get("value").toString();}).findFirst().get();
//
//
//            if(dataCode.equals("ac_stmpc_"+dataNum) && ac_modes.equals("34")){
//                if(Integer.valueOf((String) mqttSendACVO.getState())<19 || Integer.valueOf((String) mqttSendACVO.getState())>30){
//                    log.info("发送失败,制冷温度值:"+mqttSendACVO.getState()+",不在19℃-30℃范围内");
//                    return Result.success("发送失败,制冷温度值:"+mqttSendACVO.getState()+",不在19℃-30℃范围内");
//                }
//            }
//            if(dataCode.equals("ac_stmpc_"+dataNum) && ac_modes.equals("48")){
//                if(Integer.valueOf((String) mqttSendACVO.getState())<17 || Integer.valueOf((String) mqttSendACVO.getState())>30){
//                    log.info("发送失败,制热温度值:"+mqttSendACVO.getState()+",不在17℃-30℃范围内");
//                    return Result.success("发送失败,制热温度值:"+mqttSendACVO.getState()+",不在17℃-30℃范围内");
//                }
//            }
//
//            MqttBGLVO mqttBGLVO =new MqttBGLVO();
//            mqttBGLVO.setSn(sn);
//            mqttBGLVO.setDeviceCode(deviceCode);
//            mqttBGLVO.setDataCode(dataCode);
//            if(dataCode.contains("ac_modes")){
//                mqttBGLVO.setDataValue(acModel.get(mqttSendACVO.getState()));
//            }else if(dataCode.contains("ac_modec")){
//                mqttBGLVO.setDataValue(acModel.get(mqttSendACVO.getState()));
//            }else if(dataCode.contains("ac_nfc")){
//                mqttBGLVO.setDataValue(ac_nfc_Model.get(mqttSendACVO.getState()));
//            }else {
//                mqttBGLVO.setDataValue(mqttSendACVO.getState());
//            }
//
//            //默认下发类型
//            mqttBGLVO.setRwType("down");
//
//            JSONObject jsonObject = new JSONObject();
//            JSONObject jsonData = new JSONObject();
//            jsonData.put(mqttBGLVO.getDataCode(),Long.valueOf(mqttBGLVO.getDataValue().toString()));
//            jsonObject.put(mqttBGLVO.getDeviceCode(),jsonData);
//
//            topic = type+"/"+mqttBGLVO.getRwType()+"/"+mqttBGLVO.getSn();
//            pushMessage = jsonObject.toJSONString().replace("\\","");
//
//            log.info("发送消息,topic:"+topic+",pushMessage:"+pushMessage);
//            client.publish(topic,pushMessage.getBytes());
//
//
//
//        } catch (IllegalAccessException e) {
//            throw new RuntimeException(e);
//        } catch (InstantiationException e) {
//            throw new RuntimeException(e);
//        }
//        return Result.success("发布消息,topic:"+topic+",message:"+pushMessage);
//    }
//
//    public Result publish(Object data) {
//        if (ObjectUtils.isEmpty(data)) {
//            return Result.error("提交参数不能为空");
//        } else {
//            JSONObject jsonObject = JSONObject.from(data);
//            JSONObject jsonData = JSONObject.from(jsonObject.get("data"));
//            String topic = (String)jsonData.get("topic");
//            String json = (String)jsonData.get("json");
//            log.info("发布消息,topic:" + topic + ",message:" + json);
//            client.publish( topic, json.replace("\\", "").getBytes());
//            return Result.success("发送成功");
//        }
//    }

}
